<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Agent Components &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Coordinate Systems" href="coordinate_systems.html" />
    <link rel="prev" title="Simulator" href="../20_simulator_advanced.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../20_simulator_advanced.html">Simulator</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="#">Agent Components</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#action-longitudinaldriver">Action_LongitudinalDriver</a></li>
<li class="toctree-l3"><a class="reference internal" href="#action-secondarydriver">Action_SecondaryDriver</a></li>
<li class="toctree-l3"><a class="reference internal" href="#agentupdater">AgentUpdater</a></li>
<li class="toctree-l3"><a class="reference internal" href="#algorithm-lateral">Algorithm_Lateral</a></li>
<li class="toctree-l3"><a class="reference internal" href="#algorithm-longitudinal">Algorithm_Longitudinal</a></li>
<li class="toctree-l3"><a class="reference internal" href="#algorithmcar2xsender">AlgorithmCar2XSender</a></li>
<li class="toctree-l3"><a class="reference internal" href="#dynamics-collision">Dynamics_Collision</a></li>
<li class="toctree-l3"><a class="reference internal" href="#dynamics-scenario">Dynamics_Scenario</a></li>
<li class="toctree-l3"><a class="reference internal" href="#dynamics-regulardriving">Dynamics_RegularDriving</a></li>
<li class="toctree-l3"><a class="reference internal" href="#limiteraccelerationvehiclecomponents">LimiterAccelerationVehicleComponents</a></li>
<li class="toctree-l3"><a class="reference internal" href="#openscenarioactions">OpenScenarioActions</a></li>
<li class="toctree-l3"><a class="reference internal" href="#parameters-vehicle">Parameters_Vehicle</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#vehicle-model-related-parameters">Vehicle model related parameters</a></li>
<li class="toctree-l4"><a class="reference internal" href="#powertrain-related-parameters">Powertrain related parameters</a></li>
<li class="toctree-l4"><a class="reference internal" href="#steering-related-parameters">Steering related parameters</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#sensor-driver">Sensor_Driver</a></li>
<li class="toctree-l3"><a class="reference internal" href="#sensor-osi">Sensor_OSI</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#sensorgeometric2d">SensorGeometric2D</a></li>
<li class="toctree-l4"><a class="reference internal" href="#function">Function</a></li>
<li class="toctree-l4"><a class="reference internal" href="#cases">Cases</a></li>
<li class="toctree-l4"><a class="reference internal" href="#visual-obstruction">Visual Obstruction</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#sensorfusionosi">SensorFusionOSI</a></li>
<li class="toctree-l3"><a class="reference internal" href="#signalprioritizer">SignalPrioritizer</a></li>
<li class="toctree-l3"><a class="reference internal" href="#componentcontroller">ComponentController</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#overview">Overview</a></li>
<li class="toctree-l4"><a class="reference internal" href="#state-handling-inside-vehicle-component">State handling inside Vehicle Component</a></li>
<li class="toctree-l4"><a class="reference internal" href="#used-signals">Used signals</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="coordinate_systems.html">Coordinate Systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="event_detector.html">EventDetector</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario_actions.html">Mapping of OpenSCENARIO Actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulation.html">Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="spawner_features.html">Spawner Features</a></li>
<li class="toctree-l2"><a class="reference internal" href="system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a></li>
<li class="toctree-l2"><a class="reference internal" href="world_osi.html">World_OSI</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../20_simulator_advanced.html">Simulator</a></li>
      <li class="breadcrumb-item active">Agent Components</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/advanced_topics/simulator/agent_components.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="agent-components">
<span id="agentcomponents"></span><h1>Agent Components<a class="headerlink" href="#agent-components" title="Link to this heading"></a></h1>
<p>An agent in openPASS is composed of multiple modules, which are connected by corresponding signals.
As shown in the next figure, the modules can be roughly divided into the groups drivers, vehicle components, algorithms, dynamic modules, and prioritizers.
Thereby, modules can consist of several submodules, such as sensor (reading from an interface) and action (writing to an interface).</p>
<figure class="align-default" id="id2">
<img alt="../../_images/DynamicsModules.png" src="../../_images/DynamicsModules.png" />
<figcaption>
<p><span class="caption-text">Modules for longitudinal and lateral dynamics</span><a class="headerlink" href="#id2" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>By statistic means, based on corresponding probabilities defined in the <a class="reference internal" href="../../user_guide/configs/profilescatalog.html#profilescatalog"><span class="std std-ref">ProfilesCatalog</span></a>, each individual agent is composed from a superset of all possible (valid) combinations, which is defined by the <a class="reference internal" href="../../user_guide/configs/systemconfigblueprint.html#systemconfigblueprint"><span class="std std-ref">SystemConfigBlueprint</span></a>.
This config defines all available framework modules and agent modules and connects them by corresponding channels, which in turn have a specific signal type.</p>
<p>The next figure gives an exhaustive overview over the current superset:</p>
<figure class="align-default" id="id3">
<span id="component-channel-communication"></span><img alt="../../_images/ComponentsChannelCommunicationDiagram.png" src="../../_images/ComponentsChannelCommunicationDiagram.png" />
<figcaption>
<p><span class="caption-text">Components and channel communication</span><a class="headerlink" href="#id3" title="Link to this image"></a></p>
</figcaption>
</figure>
<p><a class="reference download internal" download="" href="../../_downloads/a4a21311d2dff77fb2513fe86367853b/ComponentsChannelCommunicationDiagram.drawio"><code class="xref download docutils literal notranslate"><span class="pre">./draw.io/ComponentsChannelCommunicationDiagram.drawio</span></code></a></p>
<p>Modules that can be parametrized by the user are explained in the <a class="reference internal" href="../../user_guide/sim_user_guide/20_components.html#simuserguide-components"><span class="std std-ref">Simulation User Guide</span></a>.
Therefor the following section only contains the components not listed in the user guide.</p>
<section id="action-longitudinaldriver">
<h2>Action_LongitudinalDriver<a class="headerlink" href="#action-longitudinaldriver" title="Link to this heading"></a></h2>
<p>Updates the agents pedal positions and gear.
The input for this module is prepared by the AlgorithmLongitudinal Module.</p>
</section>
<section id="action-secondarydriver">
<h2>Action_SecondaryDriver<a class="headerlink" href="#action-secondarydriver" title="Link to this heading"></a></h2>
<p>Updates the agents braking light, indicator, horn and all light switches (headlight, high beam, flasher).
The input for this module is prepared by the driver module.</p>
<p><strong>Overview of the module’s functionalities</strong></p>
<p>Action_SecondaryDriver gathers the secondary driving tasks and transfers them to output signals. Three graded driving tasks are defined and exampled as follows:</p>
<p><strong>Primary driving tasks:</strong> direct control of vehicle movements, like steering, pedal operation, shifting, etc.</p>
<p><strong>Secondary driving tasks:</strong> indirect control of vehicle movements, but supporting and complementing driving actions, like activation of indicator, horn, light, etc.</p>
<p><strong>Tertiary driving tasks:</strong> all the other activities, which are not related to vehicle control, like radio operation, etc.</p>
<p>Table list of the input paramemter:</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Value</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>in_indicatorState</p></td>
<td><p>State of the indicator</p></td>
<td><p>left, center/off, right, warn</p></td>
</tr>
<tr class="row-odd"><td><p>in_hornSwitch</p></td>
<td><p>Horn activation</p></td>
<td><p>true/false</p></td>
</tr>
<tr class="row-even"><td><p>in_headLightSwitch</p></td>
<td><p>Light activation</p></td>
<td><p>true/false</p></td>
</tr>
<tr class="row-odd"><td><p>in_highBeamLightSwitch</p></td>
<td><p>High beam light activation</p></td>
<td><p>true/false</p></td>
</tr>
<tr class="row-even"><td><p>in_flasherSwitch</p></td>
<td><p>Flasher activation</p></td>
<td><p>true/false</p></td>
</tr>
</tbody>
</table>
</section>
<section id="agentupdater">
<h2>AgentUpdater<a class="headerlink" href="#agentupdater" title="Link to this heading"></a></h2>
<p>The AgentUpdater executes all Set-Methods of the agent dynamics after the DynamicsPrioritizer. This includes position, velocity, acceleration and rotation.</p>
</section>
<section id="algorithm-lateral">
<h2>Algorithm_Lateral<a class="headerlink" href="#algorithm-lateral" title="Link to this heading"></a></h2>
<p>This module converts the lateral input of the driver module into a steering wheel angle.</p>
<p>See <a class="reference internal" href="../../user_guide/sim_user_guide/components/algorithm_lateral.html#algorithm-lateral"><span class="std std-ref">Algorithm_Lateral</span></a>.</p>
</section>
<section id="algorithm-longitudinal">
<h2>Algorithm_Longitudinal<a class="headerlink" href="#algorithm-longitudinal" title="Link to this heading"></a></h2>
<p>This module converts the acceleration input of the driver module into pedal positions and gear.</p>
<p>See <a class="reference internal" href="../../user_guide/sim_user_guide/components/algorithm_longitudinal.html#algorithm-longitudinal"><span class="std std-ref">Algorithm_Longitudinal</span></a>.</p>
</section>
<section id="algorithmcar2xsender">
<h2>AlgorithmCar2XSender<a class="headerlink" href="#algorithmcar2xsender" title="Link to this heading"></a></h2>
<p>This module publishes the below mentioned parameters in each timestep via the RadioInterface provided by the World.</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Parameter</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>SignalStrength</p></td>
<td><p>Double</p></td>
<td><p>W</p></td>
<td><p>Singal strength of the Car2XSender</p></td>
</tr>
<tr class="row-odd"><td><p>SendPositionXEnabled</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>If true, the x-coordinate of the agent is sent</p></td>
</tr>
<tr class="row-even"><td><p>SendPositionYEnabled</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>If true, the y-coordinate of the agent is sent</p></td>
</tr>
<tr class="row-odd"><td><p>SendVelocityEnabled</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>If true, the velocity of the agent is sent</p></td>
</tr>
<tr class="row-even"><td><p>SendAccelerationEnabled</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>If true, the acceleration of the agent is sent</p></td>
</tr>
<tr class="row-odd"><td><p>SendYawEnabled</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>If true, the yaw angle of the agent is sent</p></td>
</tr>
</tbody>
</table>
</section>
<section id="dynamics-collision">
<h2>Dynamics_Collision<a class="headerlink" href="#dynamics-collision" title="Link to this heading"></a></h2>
<p>If the number of collision partners of the agent is bigger than in the previous time step, the DynamicsCollision module calculates the collision.
Currently the collision is implemented fully inelastic, i.e. all agents will have the same velocity after the collision, while the momentum is conserved.
After the collision the agents slow down with a fixed deceleration until fully stopped.</p>
</section>
<section id="dynamics-scenario">
<h2>Dynamics_Scenario<a class="headerlink" href="#dynamics-scenario" title="Link to this heading"></a></h2>
<p>See <a class="reference internal" href="../../user_guide/sim_user_guide/components/dynamics_scenario.html#dynamics-scenario"><span class="std std-ref">Dynamics_Scenario</span></a>.</p>
</section>
<section id="dynamics-regulardriving">
<h2>Dynamics_RegularDriving<a class="headerlink" href="#dynamics-regulardriving" title="Link to this heading"></a></h2>
<p>The module takes care that the motion of the agent fit to the physical limitations, such as friction or maximum possible acceleration based on the current gear.
This module uses both the world friction and the vehicle model parameter friction.
Thereby it calculates the dynamics of the agents in every time step.
The currently covered  dynamics are <em>Acceleration</em>, <em>Velocity</em>, and consequently <em>Position</em>, <em>Yaw angle</em> and <em>Yaw rate</em>.
The input for this module is the steering wheel angle and the new acceleration of the vehicle.</p>
<p>See <a class="reference internal" href="../../user_guide/sim_user_guide/components/dynamics_regular_driving.html#dynamics-regular-driving"><span class="std std-ref">Dynamics_RegularDriving</span></a>.</p>
</section>
<section id="limiteraccelerationvehiclecomponents">
<h2>LimiterAccelerationVehicleComponents<a class="headerlink" href="#limiteraccelerationvehiclecomponents" title="Link to this heading"></a></h2>
<p>This module limits the AccelerationSignal from the PrioritizerAccelerationVehicleComponents to the constraints given by the vehicle. The DynamicsTrajectoryFollower can then use this signal to calculate a trajectory.</p>
<p>The limit is calculated by <img class="math" src="../../_images/math/b8e905e7f040e6ca0fbde1ee281a2e9e6aedd42c.png" alt="a_{\text{lim}} = \frac {F_{\text{wheel}} - F_{\text{roll}} - F_{\text{air}}} {m_{\text{veh}}}"/>, where the symbols meanings are:</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Symbol</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/dd0e45b188dfaf5d28adc454675a19893741bc0a.png" alt="a_{\text{lim}}"/></p></td>
<td><p>Resulting acceleration limit [m/s²]</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../_images/math/8c8c50e079ddcffe6c37e396fda0def610aec805.png" alt="F_{\text{wheel}}"/></p></td>
<td><p>Force at wheel (provided by drivetrain) [N]</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/4a145fae91306b362ee66953323a41d79fe3b613.png" alt="F_{\text{roll}}"/></p></td>
<td><p>Force resulting from rolling resistance [N]</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../_images/math/0522178ee32098e5415d0f7841ccc877c72d437b.png" alt="F_{\text{air}}"/></p></td>
<td><p>Force resulting from air drag [N]</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/1b9bc4cf466a822e0b8b1dc14b2787c6777cd1e8.png" alt="m_{\text{veh}}"/></p></td>
<td><p>Mass of the vehicle [kg]</p></td>
</tr>
</tbody>
</table>
<p>The components are calculated as follows:</p>
<p><strong>Driving force</strong></p>
<p><img class="math" src="../../_images/math/3b016a9e92ffb9f0909c19ff956ccc459864df7d.png" alt="F_{\text{wheel}} = \frac {T_{\text{engine}} \cdot r_{\text{axle}}} {r_{\text{wheel}}}"/></p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Symbol</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/692e2731d37983a19fd2b39c8101cf15d882ff35.png" alt="T_{\text{engine}}"/></p></td>
<td><p>Resulting torque from drivetrain at current velocity (assuming best gearing selected) [Nm]</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../_images/math/c424381a86be77f896401b0158f6d5634461dd46.png" alt="r_{\text{axle}}"/></p></td>
<td><p>Axle transmission ratio [1]</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/a019586eb6dacb7b6496d07fefdbb7cc2395329c.png" alt="r_{\text{wheel}}"/></p></td>
<td><p>Static radius of the wheels [m]</p></td>
</tr>
</tbody>
</table>
<p>The engine torque <img class="math" src="../../_images/math/692e2731d37983a19fd2b39c8101cf15d882ff35.png" alt="T_{\text{engine}}"/> is calculated by a simple model, where the torque scales proportional with the current engine speed between 1350 and 5000 rpm, up to maximum engine torque.
From minimum engine speed up to 1350 rpm the torque scales proportional with the engine speed up to half the maximum torque.
From 5000 rpm up to maximum engine speed, the torque scales with 5000 / maxEngineSpeed, up to maximum torque.</p>
<p><strong>Rolling resistance</strong></p>
<p><img class="math" src="../../_images/math/d39bed6c7ca56cec556eaa950eb8054adbb6cf47.png" alt="F_{\text{roll}} = m_{\text{veh}} \cdot c_{\text{fric}} \cdot g"/></p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Symbol</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/1b9bc4cf466a822e0b8b1dc14b2787c6777cd1e8.png" alt="m_{\text{veh}}"/></p></td>
<td><p>Mass of the vehicle [kg]</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../_images/math/44252e11753151d0fa1d037d8714c6f9a338302b.png" alt="c_{\text{fric}}"/></p></td>
<td><p>Rolling friction coefficient (constant 0.015) [1]</p></td>
</tr>
</tbody>
</table>
<p><strong>Air drag</strong></p>
<p><img class="math" src="../../_images/math/47d2f130adc5dfa8b9c3ae6852ad32b265775aa8.png" alt="F_{\text{air}} = \frac {\rho_{\text{air}}} {2} \cdot A_{\text{front}} \cdot c_w \cdot v^2"/></p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Symbol</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/ec29cdf2a0665b368b2c84668db684adce27d0f6.png" alt="\rho_{\text{air}}"/></p></td>
<td><p>Density of air [kg/m³]</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../_images/math/25da9109e1ebaa46fe7b79f67874d66957079266.png" alt="A_{\text{front}}"/></p></td>
<td><p>Vehicle front surface area [m²]</p></td>
</tr>
<tr class="row-even"><td><p><img class="math" src="../../_images/math/7ebeba54263779b2dc506f0fad06feb2089eee73.png" alt="c_w"/></p></td>
<td><p>Drag coefficient [1]</p></td>
</tr>
<tr class="row-odd"><td><p><img class="math" src="../../_images/math/02d98909b5d6acd6a7ff927d4d42790bdd407d58.png" alt="v"/></p></td>
<td><p>Vehicle’s current velocity [m/s]</p></td>
</tr>
</tbody>
</table>
</section>
<section id="openscenarioactions">
<h2>OpenScenarioActions<a class="headerlink" href="#openscenarioactions" title="Link to this heading"></a></h2>
<p>As defined by <a class="reference external" href="https://www.asam.net/standards/detail/openscenario/">OpenSCENARIO</a>, OpenScenarioActions is the relaying module for:</p>
<ul class="simple">
<li><p>Trajectory-actions</p></li>
<li><p>LaneChange-actions</p></li>
<li><p>UserDefined-actions.</p></li>
</ul>
<p>If a</p>
<ul class="simple">
<li><p>TrajectoryManipulator</p></li>
<li><p>LaneChangeManipulator</p></li>
</ul>
<p>or a user defined manipulator</p>
<p>raises such an event for the specified agent, the module forwards it as signal to all interested module of the corresponding agent. The modules can than react on the signals content without time delay.</p>
</section>
<section id="parameters-vehicle">
<span id="id1"></span><h2>Parameters_Vehicle<a class="headerlink" href="#parameters-vehicle" title="Link to this heading"></a></h2>
<p>The ParametersVehicle module forwards the VehicleModelParameters to all other modules that need them via the ParametersVehicleSignal.</p>
<p>This section includes all vehicle system related parameters, powertrain system related parameters and steering system related parameters.
Relevant parameters are presented in the following three tables with the corresponding explanations.</p>
<section id="vehicle-model-related-parameters">
<h3>Vehicle model related parameters<a class="headerlink" href="#vehicle-model-related-parameters" title="Link to this heading"></a></h3>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>width</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Maximum width of the vehicle</p></td>
</tr>
<tr class="row-odd"><td><p>length</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Maximum length of the vehicle</p></td>
</tr>
<tr class="row-even"><td><p>height</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Maximum height of the vehicle</p></td>
</tr>
<tr class="row-odd"><td><p>wheelbase</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Wheelbase of the vehicle</p></td>
</tr>
<tr class="row-even"><td><p>trackwidth</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Trackwidth of the vehicle</p></td>
</tr>
<tr class="row-odd"><td><p>distanceCOGtoLeadingEdge</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Distance between the COG and the front bumper</p></td>
</tr>
<tr class="row-even"><td><p>distanceCOGtoFrontAxle</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Distance between the COG and the front axle</p></td>
</tr>
<tr class="row-odd"><td><p>heightCOG</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Height of the center of gravity above ground</p></td>
</tr>
<tr class="row-even"><td><p>weight</p></td>
<td><p>Double</p></td>
<td><p>kg</p></td>
<td><p>Overall mass of the vehicle</p></td>
</tr>
<tr class="row-odd"><td><p>momentInertiaRoll</p></td>
<td><p>Double</p></td>
<td><p>kgm²</p></td>
<td><p>Moment of inertia along the vehicle’s longitudinal axis</p></td>
</tr>
<tr class="row-even"><td><p>momentInertiaPitch</p></td>
<td><p>Double</p></td>
<td><p>kgm²</p></td>
<td><p>Moment of inertia along the vehicle’s lateral axis</p></td>
</tr>
<tr class="row-odd"><td><p>momentInertiaYaw</p></td>
<td><p>Double</p></td>
<td><p>kgm²</p></td>
<td><p>Moment of inertia along the vehicle’s vertical axis</p></td>
</tr>
<tr class="row-even"><td><p>frontSurface</p></td>
<td><p>Double</p></td>
<td><p>m²</p></td>
<td><p>Projected front surface of the vehicle</p></td>
</tr>
<tr class="row-odd"><td><p>airDragCoefficient</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Air drag coefficient of the vehicle</p></td>
</tr>
</tbody>
</table>
</section>
<section id="powertrain-related-parameters">
<h3>Powertrain related parameters<a class="headerlink" href="#powertrain-related-parameters" title="Link to this heading"></a></h3>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>minimumEngineSpeed</p></td>
<td><p>Double</p></td>
<td><p>1/min</p></td>
<td><p>Idle speed of the engine</p></td>
</tr>
<tr class="row-odd"><td><p>maximumEngineSpeed</p></td>
<td><p>Double</p></td>
<td><p>1/min</p></td>
<td><p>Maximum engine speed</p></td>
</tr>
<tr class="row-even"><td><p>minimumEngineTorque</p></td>
<td><p>Double</p></td>
<td><p>Nm</p></td>
<td><p>Minimum torque of the engine</p></td>
</tr>
<tr class="row-odd"><td><p>maximumEngineTorque</p></td>
<td><p>Double</p></td>
<td><p>Nm</p></td>
<td><p>Maximum torque of the engine</p></td>
</tr>
<tr class="row-even"><td><p>numberOfGears</p></td>
<td><p>Integer</p></td>
<td></td>
<td><p>Number of gears in the gearbox</p></td>
</tr>
<tr class="row-odd"><td><p>axleRatio</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Ratio of the axle gear</p></td>
</tr>
<tr class="row-even"><td><p>decelerationFromPowertrainDrag</p></td>
<td><p>Double</p></td>
<td><p>m/s²</p></td>
<td><p>Deceleration caused by the overall powertrain drag torque</p></td>
</tr>
</tbody>
</table>
</section>
<section id="steering-related-parameters">
<h3>Steering related parameters<a class="headerlink" href="#steering-related-parameters" title="Link to this heading"></a></h3>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>steeringRatio</p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Ratio of the steering gear</p></td>
</tr>
<tr class="row-odd"><td><p>maximumSteeringWheelAngleAmplitude</p></td>
<td><p>Double</p></td>
<td><p>degree</p></td>
<td><p>Maximum amplitude of the steering wheel angle</p></td>
</tr>
</tbody>
</table>
</section>
</section>
<section id="sensor-driver">
<h2>Sensor_Driver<a class="headerlink" href="#sensor-driver" title="Link to this heading"></a></h2>
<p>The Sensor_Driver performs queries on the AgentInterface to gather information about the own agent and its surroundings.
These are forwarded to the driver modules and the Algorithm modules, which use them for their calculations.</p>
<p>See <a class="reference internal" href="../../user_guide/sim_user_guide/components/sensor_driver.html#sensor-driver"><span class="std std-ref">Sensor_Driver</span></a>.</p>
</section>
<section id="sensor-osi">
<h2>Sensor_OSI<a class="headerlink" href="#sensor-osi" title="Link to this heading"></a></h2>
<p>This module is a representation of various sensors and uses OSI for its input and output.
Currently, two types of sensors (SensorGeometric2D and ReceiverCar2X) are available.</p>
<section id="sensorgeometric2d">
<h3>SensorGeometric2D<a class="headerlink" href="#sensorgeometric2d" title="Link to this heading"></a></h3>
<p>The SensorGeometric2D detects all objects in a sector with specified range and opening angle.
The input of the sensor is a OSI SensorView generated by the OSI World and its output is a OSI SensorData structure.</p>
<p>For generation of the SensorView, a SensorViewConfiguration has to be provided by the sensor to the OSI World. See image for a visualization of the
dataflow.</p>
<figure class="align-default" id="id4">
<img alt="../../_images/SensorView_Dataflow.png" src="../../_images/SensorView_Dataflow.png" />
<figcaption>
<p><span class="caption-text">OSI SensorView dataflow</span><a class="headerlink" href="#id4" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>From OSI development perspective, the OSI World would have to send back a SensorViewConfiguration to the sensor, with the contents describing the
actual configuration of the SensorView (since the World is maybe notable to provide the requested information).
As we have full control over the simulation environment, this back-channel is skipped and SensorView according to the sensor’S SensorView configuration
will always be provided.</p>
<p>To test whether an object is inside our sector we check
1. if it is inside the circle around the sensor with radius the detection range and
2. if it intersects a suitable polygon</p>
<p>Depending on the opening-angle the polygon in 2) has either four (angle &lt; 180°) or five corners (angle &gt;= 180°).</p>
<figure class="align-default" id="id5">
<img alt="../../_images/sensor2d_kite_polygon.svg" src="../../_images/sensor2d_kite_polygon.svg" /><figcaption>
<p><span class="caption-text">four-corner kite polygon for angle lower than 180°</span><a class="headerlink" href="#id5" title="Link to this image"></a></p>
</figcaption>
</figure>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Object</p></th>
<th class="head"><p>intersects circle</p></th>
<th class="head"><p>intersects polygon</p></th>
<th class="head"><p>detected</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>A</p></td>
<td><p>true</p></td>
<td><p>false</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-odd"><td><p>B</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
</tr>
<tr class="row-even"><td><p>C</p></td>
<td><p>false</p></td>
<td><p>true</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-odd"><td><p>D</p></td>
<td><p>false</p></td>
<td><p>false</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-even"><td><p>E</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
</tr>
</tbody>
</table>
<figure class="align-default" id="id6">
<img alt="../../_images/sensor2d_five_corner_polygon.svg" src="../../_images/sensor2d_five_corner_polygon.svg" /><figcaption>
<p><span class="caption-text">five-corner polygon for angle greater or equal 180° and greater 360°</span><a class="headerlink" href="#id6" title="Link to this image"></a></p>
</figcaption>
</figure>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Object</p></th>
<th class="head"><p>intersects circle</p></th>
<th class="head"><p>intersects polygon</p></th>
<th class="head"><p>detected</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>A</p></td>
<td><p>false</p></td>
<td><p>true</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-odd"><td><p>B</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
</tr>
<tr class="row-even"><td><p>C</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
<td><p>true</p></td>
</tr>
<tr class="row-odd"><td><p>D</p></td>
<td><p>true</p></td>
<td><p>false</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-even"><td><p>E</p></td>
<td><p>false</p></td>
<td><p>false</p></td>
<td><p>false</p></td>
</tr>
</tbody>
</table>
<p>For convex BBoxes the above will give correct detection results.</p>
<p>Both polygons are constructed from corner-points consisting out of the intersection between the opening-angle boundaries at maximum detection range and their corresponding tangents.</p>
</section>
<section id="function">
<h3>Function<a class="headerlink" href="#function" title="Link to this heading"></a></h3>
<ol class="arabic simple">
<li><p>Construct the polygon based on the opening-angle</p></li>
<li><p>Check if detection-field (polygon) intersects with any BBox (object-detection)</p></li>
<li><p>Calculate the distance between sensor and object</p></li>
<li><p>if (dist &lt;= range &amp;&amp; isIntersecting) -&gt; object is in circular sector (object validation)</p></li>
</ol>
</section>
<section id="cases">
<h3>Cases<a class="headerlink" href="#cases" title="Link to this heading"></a></h3>
<ul class="simple">
<li><p>For angles &lt; 1.0 * pi a four-corner (kite) polygon can be constructed out of two radiuses and two tangents.</p></li>
<li><p>For angles &gt; = 1.0 * pi and &lt; 2.0 * pi a five-corner polygon can be constructed of two radiuses an three tangents.</p></li>
<li><p>For opening-angle of exactly 2.0 * pi the distance information suffices. No polygon is needed.</p></li>
</ul>
</section>
<section id="visual-obstruction">
<h3>Visual Obstruction<a class="headerlink" href="#visual-obstruction" title="Link to this heading"></a></h3>
<p>Objects in front of others block the sensors line of sight.
If an object is large enough it might visually obstruct others.
To check if one or multiple objects in combination “shadow” other objects the flag <code class="docutils literal notranslate"><span class="pre">EnableVisualObstruction</span></code> can be set.
Also the minimum required percentage of the visible area of an object to be detected can be specified.
The implemented algorithm uses the concept of shadow-casting, where the sensor cone is assumed to be the light source and the resulting shadow is calculated for each object.
If an object is shadowed too much, it is removed from the list of detected objects.</p>
<p>Shadow casting is calculated as follows:</p>
<ol class="arabic simple">
<li><p>Approximate detection field as circular sector.</p></li>
<li><p>Calculate the casted shadow of each object inside the detection field.</p></li>
<li><p>Remove bounding box of object from shadow, so that it can be detected.</p></li>
<li><p>Remove the casted shadow from the detection field.</p></li>
<li><p>For each object, check if remaining area is inside the remaining polygon.</p></li>
<li><p>Remove objects, if relation <code class="docutils literal notranslate"><span class="pre">covered</span> <span class="pre">object</span> <span class="pre">area/total</span> <span class="pre">object</span> <span class="pre">area</span></code> is smaller than a parameterizable threshold.</p></li>
</ol>
<p><strong>Example</strong></p>
<p>Assume that the vehicle ahead is fully captured by the following vehicle’s sensor cone.
The outer points of the bounding box define the cone of the shadow.</p>
<figure class="align-default" id="id7">
<img alt="../../_images/shadow_casting_step01.svg" src="../../_images/shadow_casting_step01.svg" /><figcaption>
<p><span class="caption-text">Vehicle within sensor range</span><a class="headerlink" href="#id7" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>For calculation of the shadow polygon, these boundary vectors needs to be extended w.r.t. detection range.</p>
<p>In order to calculate the shadow polygon, the bounding vectors needs to be scaled with regard to the detection area.
Note that extending only to the edges of the detection area would produce too small a shadow.</p>
<figure class="align-default" id="id8">
<img alt="../../_images/shadow_casting_step02.svg" src="../../_images/shadow_casting_step02.svg" /><figcaption>
<p><span class="caption-text">Too small shadow with missing area in red</span><a class="headerlink" href="#id8" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>To avoid numerical scaling problems related to the length of the bounding vectors, the shadow is not stretched to a fixed size.
Instead, the internal algorithm overestimates the size of the shadow, with the detection range as a guaranteed lower limit.</p>
<figure class="align-default" id="id9">
<img alt="../../_images/shadow_casting_step03.svg" src="../../_images/shadow_casting_step03.svg" /><figcaption>
<p><span class="caption-text">Overestimated shadow</span><a class="headerlink" href="#id9" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>For this guarantee, the actual detection area must be approximated along the edge of the ideal circle (rather than by a tangential approximation).
With regard to typical object sizes and detection areas, the error can be considered negligible.</p>
<figure class="align-default" id="id10">
<img alt="../../_images/shadow_casting_step04.svg" src="../../_images/shadow_casting_step04.svg" /><figcaption>
<p><span class="caption-text">Approximation of the sensor cone</span><a class="headerlink" href="#id10" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>Next, the object’s bounding box is removed from the shadow.</p>
<figure class="align-default" id="id11">
<img alt="../../_images/shadow_casting_step05.svg" src="../../_images/shadow_casting_step05.svg" /><figcaption>
<p><span class="caption-text">Approximated sensor cone and shadow with removed bounding box</span><a class="headerlink" href="#id11" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>Finally, the shadow is subtracted from the sensor cone.</p>
<figure class="align-default" id="id12">
<img alt="../../_images/shadow_casting_step06.svg" src="../../_images/shadow_casting_step06.svg" /><figcaption>
<p><span class="caption-text">Sensor cone with removed shadow</span><a class="headerlink" href="#id12" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>The process is repeated for each object in the detection area.</p>
<figure class="align-default" id="id13">
<img alt="../../_images/shadow_casting_step07.svg" src="../../_images/shadow_casting_step07.svg" /><figcaption>
<p><span class="caption-text">Shadow of partially occluded vehicle</span><a class="headerlink" href="#id13" title="Link to this image"></a></p>
</figcaption>
</figure>
<figure class="align-default" id="id14">
<img alt="../../_images/shadow_casting_step08.svg" src="../../_images/shadow_casting_step08.svg" /><figcaption>
<p><span class="caption-text">Sensor cone with removed shadow of partially occluded vehicle</span><a class="headerlink" href="#id14" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>Note that the order of shadow calculation and subtraction is irrelevant.</p>
</section>
</section>
<section id="sensorfusionosi">
<h2>SensorFusionOSI<a class="headerlink" href="#sensorfusionosi" title="Link to this heading"></a></h2>
<p>The SensorFusionOSI module allows unsorted aggregation of any data provided by sensors. All sampled detected objects can then be broadcasted to connected ADAS.</p>
<p>It collects all SensorDataSignals and merges them into a single SensorDataSignal.</p>
</section>
<section id="signalprioritizer">
<span id="agentcomponents-signalprioritizer"></span><h2>SignalPrioritizer<a class="headerlink" href="#signalprioritizer" title="Link to this heading"></a></h2>
<p>All channels can only have one source.
If one module can have the same input type from multiple sources a prioritizer module is needed in between.
All sources then get an output channel to the prioritizer module and the prioritizer gets an output to the module, which uses this signal.
If more than an component sends an active signal during the same timestep, the prioritizer forwards only the signal from the input channel with the highest priority.
These priorities are set as parameters in the systemconfigblueprint.xml, where the key corresponds the the id of the input channel and the value is the priority (higher value is prioritized).
In the following example the channel with id 102 has the highest priority (3) and the channel with id 100 has the lowest priority (1).</p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;component&gt;</span>
<span class="w">  </span><span class="nt">&lt;id&gt;</span>PrioritizerName<span class="nt">&lt;/id&gt;</span>
<span class="w">  </span><span class="nt">&lt;schedule&gt;</span>
<span class="w">    </span><span class="nt">&lt;priority&gt;</span>150<span class="nt">&lt;/priority&gt;</span>
<span class="w">    </span><span class="nt">&lt;offset&gt;</span>0<span class="nt">&lt;/offset&gt;</span>
<span class="w">    </span><span class="nt">&lt;cycle&gt;</span>100<span class="nt">&lt;/cycle&gt;</span>
<span class="w">    </span><span class="nt">&lt;response&gt;</span>0<span class="nt">&lt;/response&gt;</span>
<span class="w">  </span><span class="nt">&lt;/schedule&gt;</span>
<span class="w">  </span><span class="nt">&lt;library&gt;</span>SignalPrioritizer<span class="nt">&lt;/library&gt;</span>
<span class="w">  </span><span class="nt">&lt;parameters&gt;</span>
<span class="w">    </span><span class="nt">&lt;parameter&gt;</span>
<span class="w">      </span><span class="nt">&lt;id&gt;</span>100<span class="nt">&lt;/id&gt;</span>
<span class="w">      </span><span class="nt">&lt;type&gt;</span>int<span class="nt">&lt;/type&gt;</span>
<span class="w">      </span><span class="nt">&lt;unit/&gt;</span>
<span class="w">      </span><span class="nt">&lt;value&gt;</span>1<span class="nt">&lt;/value&gt;</span>
<span class="w">    </span><span class="nt">&lt;/parameter&gt;</span>
<span class="w">    </span><span class="nt">&lt;parameter&gt;</span>
<span class="w">      </span><span class="nt">&lt;id&gt;</span>101<span class="nt">&lt;/id&gt;</span>
<span class="w">      </span><span class="nt">&lt;type&gt;</span>int<span class="nt">&lt;/type&gt;</span>
<span class="w">      </span><span class="nt">&lt;unit/&gt;</span>
<span class="w">      </span><span class="nt">&lt;value&gt;</span>2<span class="nt">&lt;/value&gt;</span>
<span class="w">    </span><span class="nt">&lt;/parameter&gt;</span>
<span class="w">    </span><span class="nt">&lt;parameter&gt;</span>
<span class="w">      </span><span class="nt">&lt;id&gt;</span>102<span class="nt">&lt;/id&gt;</span>
<span class="w">      </span><span class="nt">&lt;type&gt;</span>int<span class="nt">&lt;/type&gt;</span>
<span class="w">      </span><span class="nt">&lt;unit/&gt;</span>
<span class="w">      </span><span class="nt">&lt;value&gt;</span>3<span class="nt">&lt;/value&gt;</span>
<span class="w">    </span><span class="nt">&lt;/parameter&gt;</span>
<span class="w">  </span><span class="nt">&lt;/parameters&gt;</span>
<span class="nt">&lt;/component&gt;</span>
</pre></div>
</div>
<p>One prioritizer module can only handle signals of the same type and the signal class must be derived from ComponentStateSignal.
If there is no signal in one time step, then the signal of the previous time step is hold.</p>
<p><strong>Existing prioritizer modules</strong></p>
<ul class="simple">
<li><p>PrioritizerAccelerationVehicleComponents</p></li>
<li><p>PrioritizerSteeringVehicleComponents</p></li>
<li><p>PrioritizerTurningIndicator</p></li>
<li><p>PrioritizerLongitudinal</p></li>
<li><p>PrioritizerSteering</p></li>
<li><p>PrioritizerDynamics</p></li>
</ul>
</section>
<section id="componentcontroller">
<span id="agentcomponents-componentcontroller"></span><h2>ComponentController<a class="headerlink" href="#componentcontroller" title="Link to this heading"></a></h2>
<section id="overview">
<h3>Overview<a class="headerlink" href="#overview" title="Link to this heading"></a></h3>
<p>The ComponentController (CC) is used to configure and handle dependencies between other vehicle components.</p>
<p>Example use cases could be:</p>
<ul class="simple">
<li><p>Cruise control:</p>
<ul>
<li><p>driver requesting higher acceleration than cruise control overrides the latter</p></li>
<li><p>driver braking deactivates cruise control</p></li>
</ul>
</li>
<li><p>Lane keeping assistant:</p>
<ul>
<li><p>cannot be activated by driver, if emergency braking is currently active</p></li>
<li><p>stays active, when emergency braking occurs (i. e. by other ADAS)</p></li>
</ul>
</li>
</ul>
<p>The responsibilies of the CC are:</p>
<ul class="simple">
<li><p>Handling of all dependencies between <em>VehicleComponents</em> in case a component wants to activate</p></li>
<li><p>Make information about driver, <em>TrajectoryFollower</em> and other <em>VehicleComponents</em> available to each other</p></li>
<li><p>Determine the highest allowed activation state of a component and notify the affected component about this state</p></li>
</ul>
<p>To achieve this tasks, each component is assigned a maximum allowed state in each time step. This state is of type ComponentState,
which defines <em>Disabled</em>, <em>Armed</em> or <em>Active</em> as allowed states.
Drivers can be in a state of either <em>Active</em> or <em>Passive</em>.</p>
</section>
<section id="state-handling-inside-vehicle-component">
<h3>State handling inside Vehicle Component<a class="headerlink" href="#state-handling-inside-vehicle-component" title="Link to this heading"></a></h3>
<p>Within a vehicle component, the information flow should be implemented as follows:</p>
<ol class="arabic simple">
<li><p>The vehicle component retrieves the information of other components and the current maximum allowed state from the CC.
Other components include drivers, trajectory followers and all other vehicle components connected to the CC.</p></li>
<li><p>Based on that information the vehicle component determines its current desired state.</p></li>
<li><p>The desired state is sent to the CC.</p></li>
</ol>
<p>The CC handles all the dependencies between different components and determines the maximum allowed state for each component based
on the configuration of the CC.</p>
</section>
<section id="used-signals">
<h3>Used signals<a class="headerlink" href="#used-signals" title="Link to this heading"></a></h3>
<p>The CC communicates with the controlled components via framework signals.</p>
<p>Inputs to the ComponentController:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Source</p></th>
<th class="head"><p>Contents</p></th>
<th class="head"><p>Signal</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>TrajectoryFollower</p></td>
<td><p>Current state</p></td>
<td><p>ComponentStateSignal</p></td>
</tr>
<tr class="row-odd"><td><p>Driver</p></td>
<td><p>Current state, pedal activity</p></td>
<td><p>DriverStateSignal</p></td>
</tr>
<tr class="row-even"><td><p>VehicleComponent</p></td>
<td><p>Current state, desired state, generic ADAS parameters</p></td>
<td><p>VehicleCompToCompCtrlSignal</p></td>
</tr>
</tbody>
</table>
<p>Output to other components:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Destination</p></th>
<th class="head"><p>Contents</p></th>
<th class="head"><p>Signal</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>TrajectoryFollower</p></td>
<td><p>Current max. reachable state</p></td>
<td><p>ComponentStateSignal</p></td>
</tr>
<tr class="row-odd"><td><p>Driver</p></td>
<td><p>List of all ADAS with names, stati and types</p></td>
<td><p>AdasStateSignal</p></td>
</tr>
<tr class="row-even"><td><p>VehicleComponent</p></td>
<td><p>Current max. reachable state, list of all ADAS with names, stati and types</p></td>
<td><p>CompCtrlToVehicleCompSignal</p></td>
</tr>
</tbody>
</table>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../20_simulator_advanced.html" class="btn btn-neutral float-left" title="Simulator" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="coordinate_systems.html" class="btn btn-neutral float-right" title="Coordinate Systems" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>